/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "boostcpp.h"

#include "boostc.h"
#include "boost_generator.h"

//----------------------------------------------------------------------------
bool Boost::CompilerCpp::checkExecutableResult(bool, QStringList &lines) const
{
  return ( lines.count()>0 && lines[0].startsWith("BoostC++ ") );
}

//----------------------------------------------------------------------------
Boost::GroupCpp::GroupCpp(Pic::Architecture architecture)
  : Group(architecture, ".cpp", "void main(void) {}\n")
{}

QString Boost::GroupCpp::downloadText() const
{
  return i18n("<a href=\"http://www.sourceboost.com/Products/BoostCpp/Overview.html\">BoostC++ Compiler</a> is a C compiler distributed by SourceBoost Technologies.");
}

Tool::Base *Boost::GroupCpp::baseFactory(Tool::Category category) const
{
  if ( category==Tool::Linker ) {
    if ( _architecture==Pic::Arch_16X ) return new Boost::Linker16;
    return new Boost::Linker18;
  }
  if ( category==Tool::Compiler ) {
    if ( _architecture==Pic::Arch_16X ) return new Boost::CompilerCpp16;
    return new Boost::CompilerCpp18;
  }
  return 0;
}

Tool::SourceGenerator *Boost::GroupCpp::sourceGeneratorFactory() const
{
  return new CSourceGenerator;
}
