/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "jal_compile.h"

#include "jal.h"
#include "common/common/misc.h"

//-----------------------------------------------------------------------------
void JAL::CompileFile::logStderrLine(const QString &line)
{
  if ( line.contains('\r') ) return; // what are those lines ?
  // #### TODO
  _manager->log(Log::Data, line); // unrecognized
}

//-----------------------------------------------------------------------------
QStringList JAL::CompileFileStandalone::genericArguments(const Compile::Config &) const
{
  return "%I";
}

Compile::FileData::List JAL::CompileFileStandalone::files() const
{
  Compile::FileData::List files;
  files += fileData(PURL::AsmGPAsm, Compile::Generated | Compile::InProject);
  files += fileData(PURL::Hex, Compile::Generated | Compile::Show | Compile::InProject);
  return files;
}

//-----------------------------------------------------------------------------
QStringList JAL::CompileFileProject::genericArguments(const Compile::Config &) const
{
  return "%I";
}

Compile::FileData::List JAL::CompileFileProject::files() const
{
  Compile::FileData::List files;
  files += fileData(PURL::AsmGPAsm, Compile::Generated | Compile::InProject);
  files += fileData(PURL::Hex, Compile::Generated | Compile::InProject);
  return files;
}
